

<!DOCTYPE html>

<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>7.3.52. reindex &#8212; Groonga v10.1.1-31-g1e46ba6 documentation</title>
    <link rel="stylesheet" href="../../_static/groonga.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script src="../../_static/language_data.js"></script>
    
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="7.3.53. request_cancel" href="request_cancel.html" />
    <link rel="prev" title="7.3.51. register" href="register.html" /> 
  </head><body>
<div class="header">
  <h1 class="title">
    <a id="top-link" href="../../index.html">
      <span class="project">groonga</span>
      <span class="separator">-</span>
      <span class="description">An open-source fulltext search engine and column store.</span>
    </a>
  </h1>

  <div class="other-language-links">
    <ul>
      <li><a href="../../../../ja/html/reference/commands/reindex.html">日本語</a></li>
    </ul>
  </div>
</div>
  

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="request_cancel.html" title="7.3.53. request_cancel"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="register.html" title="7.3.51. register"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../command.html" accesskey="U"><span class="section-number">7.3. </span>Command</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.3.52. </span><code class="docutils literal notranslate"><span class="pre">reindex</span></code></a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="reindex">
<h1><span class="section-number">7.3.52. </span><code class="docutils literal notranslate"><span class="pre">reindex</span></code><a class="headerlink" href="#reindex" title="Permalink to this headline">¶</a></h1>
<div class="section" id="summary">
<h2><span class="section-number">7.3.52.1. </span>Summary<a class="headerlink" href="#summary" title="Permalink to this headline">¶</a></h2>
<div class="versionadded">
<p><span class="versionmodified added">New in version 5.1.0.</span></p>
</div>
<p><code class="docutils literal notranslate"><span class="pre">reindex</span></code> command recreates one or more index columns.</p>
<p>If you specify a database as target object, all index columns are
recreated.</p>
<p>If you specify a table as target object, all index columns in the
table are recreated.</p>
<p>If you specify a data column as target object, all index columns for
the data column are recreated.</p>
<p>If you specify an index column as target object, the index column is
recreated.</p>
<p>This command is useful when your index column is broken. The target
object is one of database, table and column.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>You can’t use target index columns while <code class="docutils literal notranslate"><span class="pre">reindex</span></code> command is
running. If you use the same database from multiple processes, all
processes except running <code class="docutils literal notranslate"><span class="pre">reindex</span></code> should reopen the
database. You can use <a class="reference internal" href="database_unmap.html"><span class="doc">database_unmap</span></a> for reopening database.</p>
</div>
</div>
<div class="section" id="syntax">
<h2><span class="section-number">7.3.52.2. </span>Syntax<a class="headerlink" href="#syntax" title="Permalink to this headline">¶</a></h2>
<p>This command takes only one optional parameter:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>reindex [target_name=null]
</pre></div>
</div>
<p>If <code class="docutils literal notranslate"><span class="pre">target_name</span></code> parameters is omitted, database is used for the
target object. It means that all index columns in the database are
recreated.</p>
</div>
<div class="section" id="usage">
<h2><span class="section-number">7.3.52.3. </span>Usage<a class="headerlink" href="#usage" title="Permalink to this headline">¶</a></h2>
<p>Here is an example to recreate all index columns in the database:</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>reindex
# [[0, 1337566253.89858, 0.000355720520019531], true]
</pre></div>
</div>
<p>Here is an example to recreate all index columns
(<code class="docutils literal notranslate"><span class="pre">Lexicon.entry_key</span></code> and <code class="docutils literal notranslate"><span class="pre">Lexicon.entry_body</span></code>) in <code class="docutils literal notranslate"><span class="pre">Lexicon</span></code>
table:</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>table_create Entry TABLE_HASH_KEY ShortText
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Entry body COLUMN_SCALAR Text
# [[0, 1337566253.89858, 0.000355720520019531], true]
table_create Lexicon TABLE_PAT_KEY ShortText \
  --default_tokenizer TokenBigram \
  --normalizer NormalizerAuto
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Lexicon entry_key COLUMN_INDEX|WITH_POSITION \
  Entry _key
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Lexicon entry_body COLUMN_INDEX|WITH_POSITION \
  Entry body
# [[0, 1337566253.89858, 0.000355720520019531], true]
reindex Lexicon
# [[0, 1337566253.89858, 0.000355720520019531], true]
</pre></div>
</div>
<p>Here is an example to recreate all index columns
(<code class="docutils literal notranslate"><span class="pre">BigramLexicon.site_title</span></code> and <code class="docutils literal notranslate"><span class="pre">RegexpLexicon.site_title</span></code>) of
<code class="docutils literal notranslate"><span class="pre">Site.title</span></code> data column:</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>table_create Site TABLE_HASH_KEY ShortText
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Site title COLUMN_SCALAR ShortText
# [[0, 1337566253.89858, 0.000355720520019531], true]
table_create BigramLexicon TABLE_PAT_KEY ShortText \
  --default_tokenizer TokenBigram \
  --normalizer NormalizerAuto
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create BigramLexicon site_title COLUMN_INDEX|WITH_POSITION \
  Site title
# [[0, 1337566253.89858, 0.000355720520019531], true]
table_create RegexpLexicon TABLE_PAT_KEY ShortText \
  --default_tokenizer TokenRegexp \
  --normalizer NormalizerAuto
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create RegexpLexicon site_title COLUMN_INDEX|WITH_POSITION \
  Site title
# [[0, 1337566253.89858, 0.000355720520019531], true]
reindex Site.title
# [[0, 1337566253.89858, 0.000355720520019531], true]
</pre></div>
</div>
<p>Here is an example to recreate an index column (<code class="docutils literal notranslate"><span class="pre">Timestamp.index</span></code>):</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>table_create Logs TABLE_NO_KEY
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Logs timestamp COLUMN_SCALAR Time
# [[0, 1337566253.89858, 0.000355720520019531], true]
table_create Timestamp TABLE_PAT_KEY Time
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Timestamp logs_timestamp COLUMN_INDEX  Logs timestamp
# [[0, 1337566253.89858, 0.000355720520019531], true]
reindex Timestamp.logs_timestamp
# [[0, 1337566253.89858, 0.000355720520019531], true]
</pre></div>
</div>
</div>
<div class="section" id="parameters">
<h2><span class="section-number">7.3.52.4. </span>Parameters<a class="headerlink" href="#parameters" title="Permalink to this headline">¶</a></h2>
<p>This section describes all parameters.</p>
<div class="section" id="target-name">
<h3><span class="section-number">7.3.52.4.1. </span><code class="docutils literal notranslate"><span class="pre">target_name</span></code><a class="headerlink" href="#target-name" title="Permalink to this headline">¶</a></h3>
<p>Specifies the name of table or column.</p>
<p>If you don’t specify it, database is used for the target object.</p>
<p>The default is none. It means that the target object is database.</p>
</div>
</div>
<div class="section" id="return-value">
<h2><span class="section-number">7.3.52.5. </span>Return value<a class="headerlink" href="#return-value" title="Permalink to this headline">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">reindex</span></code> command returns whether recreation is succeeded or not:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>[HEADER, SUCCEEDED_OR_NOT]
</pre></div>
</div>
<p><code class="docutils literal notranslate"><span class="pre">HEADER</span></code></p>
<blockquote>
<div><p>See <a class="reference internal" href="../command/output_format.html"><span class="doc">Output format</span></a> about <code class="docutils literal notranslate"><span class="pre">HEADER</span></code>.</p>
</div></blockquote>
<p><code class="docutils literal notranslate"><span class="pre">SUCCEEDED_OR_NOT</span></code></p>
<blockquote>
<div><p>If command succeeded, it returns true, otherwise it returns false on
error.</p>
</div></blockquote>
</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../../index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">7.3.52. <code class="docutils literal notranslate"><span class="pre">reindex</span></code></a><ul>
<li><a class="reference internal" href="#summary">7.3.52.1. Summary</a></li>
<li><a class="reference internal" href="#syntax">7.3.52.2. Syntax</a></li>
<li><a class="reference internal" href="#usage">7.3.52.3. Usage</a></li>
<li><a class="reference internal" href="#parameters">7.3.52.4. Parameters</a><ul>
<li><a class="reference internal" href="#target-name">7.3.52.4.1. <code class="docutils literal notranslate"><span class="pre">target_name</span></code></a></li>
</ul>
</li>
<li><a class="reference internal" href="#return-value">7.3.52.5. Return value</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="register.html"
                        title="previous chapter"><span class="section-number">7.3.51. </span><code class="docutils literal notranslate"><span class="pre">register</span></code></a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="request_cancel.html"
                        title="next chapter"><span class="section-number">7.3.53. </span><code class="docutils literal notranslate"><span class="pre">request_cancel</span></code></a></p>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="request_cancel.html" title="7.3.53. request_cancel"
             >next</a> |</li>
        <li class="right" >
          <a href="register.html" title="7.3.51. register"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../command.html" ><span class="section-number">7.3. </span>Command</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.3.52. </span><code class="docutils literal notranslate"><span class="pre">reindex</span></code></a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2021, Brazil, Inc.
    </div>
  </body>
</html>